const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const milestones = sequelize.define(
    'milestones',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

target_value: {
        type: DataTypes.DECIMAL,
      
      

      },

due_at: {
        type: DataTypes.DATE,
      
      

      },

achieved_at: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"achieved",


"missed",


"canceled"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  milestones.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.milestones.belongsTo(db.goals, {
      as: 'goal',
      foreignKey: {
        name: 'goalId',
      },
      constraints: false,
    });




    db.milestones.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.milestones.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return milestones;
};


